﻿
using System;
using System.Threading.Tasks;
using Wisej.Web;

namespace WisejAsyncSessionSample
{
	public partial class Window1 : Form
	{
		public Window1()
		{
			InitializeComponent();
		}

		// Simulates a long running task.
		private async Task FillSessionConfig()
		{
			var session = Application.Session;

			session.Config = new
			{
				Name = "someName",
				TimeStamp = DateTime.Now.Ticks,
			};

			await Task.Delay(1000);
		}

		private async Task PrintSessionConfig()
		{
			this.ShowLoader = true;

			await Application.StartTask(async () =>
			{
				// Fill the session config.
				await FillSessionConfig();

				// Print the session config.
				var session = Application.Session;
				var config = session.Config;

				AlertBox.Show($"Name: {config.Name}\nTimeStamp: {config.TimeStamp}");

				Application.Update(this);
			});

			await Task.Delay(200);
			this.ShowLoader = false;
			Application.Update(this);
		}

		private async void Window1_Load(object sender, EventArgs e)
		{
			await PrintSessionConfig();
		}
	}
}
